/**************************************************************************
**       Title: simple functions to adjust the uniqueID's of feature vectors
**    $RCSfile: adjustUniqueIDs.hh,v $
**   $Revision: 1.3 $$Name:  $
**       $Date: 2005/01/28 14:03:30 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: adjustUniqueIDs.hh,v $
**  Revision 1.3  2005/01/28 14:03:30  fehr
**  some include bugfixing for external library use
**
**  Revision 1.2  2004/09/03 09:12:41  ronneber
**  - uses Accessor now
**
**  Revision 1.1  2004/08/26 08:36:59  ronneber
**  initital import
**
**
**
**************************************************************************/

#ifndef ADJUSTUNIQUEIDS_HH
#define ADJUSTUNIQUEIDS_HH

#include "DirectAccessor.hh"
#include "DereferencingAccessor.hh"

namespace svt
{
  
  template<typename ForwardIter, typename Accessor>
  void adjustUniqueIDs( const ForwardIter& fvBegin, 
                        const ForwardIter& fvEnd,
                        Accessor accessor)
  {
    unsigned int size = fvEnd - fvBegin;
    ForwardIter p = fvBegin;
    for( unsigned int i = 0; i < size; ++i, ++p)
    {
      accessor(p).setUniqueID(i);
    }
  }
  
  template< typename FV>
  void adjustUniqueIDs( std::vector<FV*>& featureVectorPointers)
  {
    adjustUniqueIDs( featureVectorPointers.begin(), 
                     featureVectorPointers.end(),
                     DereferencingAccessor());
  }
  
  template< typename FV>
  void adjustUniqueIDs( std::vector<FV>& featureVectors)
  {
    adjustUniqueIDs( featureVectors.begin(),
                     featureVectors.end(),
                     DirectAccessor());
  }
  
  
}

#endif
