#include <vector>
namespace svt
{
  
template< typename KF>
class SVM
{
protected:
  
  KF p_kernel;
  double _terminationEpsilon;   // epsilon as termination criterium
  float  _cacheSizeMB; // cache size in Mega-Bytes
  bool   _shrinkingFlag; // flag, wether to do shrinking during training
};

template< typename KF>
class TwoClassSVM : public SVM<KF>
{
public:
    template< typename FV, typename ForwardIter>
    void calcClassificationCache(const FV& testObject, 
                                 const ForwardIter& SVP_begin,  
                                 const ForwardIter& SVP_end,
                                 std::vector<double>& kernelResultByUID) const;
};
}

template< typename KF>
template< typename FV, typename ForwardIter>
void svt::TwoClassSVM<KF>::calcClassificationCache( 
    const FV& testObject, 
    const ForwardIter& SVP_begin,  
    const ForwardIter& SVP_end,
    std::vector<double>& kernelResultByUID) const
{

  for( ForwardIter p = SVP_begin; p != SVP_end; ++p)
  {
    unsigned int i = (*p)->uniqueID();
    SVM_ASSERT( i <= kernelResultByUID.size());
    kernelResultByUID[i] = p_kernel.k_function( testObject, **p);
  }  
}

int main(void)
{
  return 0;
}
